<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<head>
		  <link href="http://funky.sourceforge.net/doxygen/doxygen.css" rel="stylesheet" type="text/css"/>

</head>
<html xmlns="http://www.w3.org/1999/xhtml">
		  <body class="sitebody">
					 <h1>Welcome to the Funky embeddable interpreter and programming language</h1>
					 <p>As the <a href="doxygen/index.html">documentation</a> will tll you, Funky is a tiny, easily embeddable functional programming language, written in C++. As the language and the interpreter are both pretty small, there is nothing much to tell about them, except perhaps the "when", "why", "what" and "how" of its history, so here goes..</p>

					 <h2>When was Funky created?</h2>
					 <p>The very first version of Funky was created during my daughter's nap on a snowy sunday afternoon. It was slightly refined one evening while my daughter and my wife were both sleeping and I was rocking the baby's "cozy" with my foot (as I am doing now). The initial programming therefore took about 90 minutes, whereas a bit of fine-tuning and turning the original parser/interpreter into a parser/interpreter with two phases (parsing and interpreting) took another two hours or so.</p>

					 <h2>Why was Funky created?</h2>
					 <p>The original idea wasn't mine: at work, a colleague needed a functional, embeddable programming language and created one from scratch. It took him a few days to do so, but he wrote the parser and the scanner by hand. I heard about his little language and thought it might be a nice idea to have one of those in the free world.</p>
					 <p>Also, as a personal challenge, I decided I should be able to write one of those in much less time that a few days, but using the right tools. Hence, one sunday afternoon I took my laptop computer and started typing. I decided to use <a href="http://spirit.sourceforge.net" target="_blank">Boost.Spirit</a> to write the parser: I had already read the documentation once while doing some research for the <a href="http://jail-ust.sf.net">Jail programming language</a> and found it a pretty good framework to build a parser one. 90 minutes later, I had the first working version of a Funky interpreter (but it wasn't embeddable yet and didn't split the parsing and interpreting phases).</p>

					 <h2>So, what exactly is Funky?</h2>
					 <p>As stated, Funky is a tiny, embeddable programming language with almost unlimited extending capabilities. It presents itself as a single class, <span class="fragment">Funky::Funky</span>, which contains the entire interpreter. You can install your own functions in the language as long as your functions take a vector of doubles as parameter and return a double.</p>
					 <p>Funky is a <em>functional</em> programming language. As such, it treats everything as functions and those functions handle only one type: <span class="fragment">double</span>, the larger floating-point built-in type from C++. I've chosen <span class="fragment">double</span> as my one-and-only built-in type because it is the most versatile of built-in types: using <span class="fragment">int</span> would have resulted in faster computation, but would severely limit the potential use of the language: functional languages are usually used for math, and integer-only math doesn't usually get you very far.</p>
					 <p>The <a href="doxygen/index.html">documentation</a> provided on this site is far more exhaustive than I care to be on this page, so for more details I'll refer you there..</p>

					 <h2>How does Funky work?</h2>
					 <p>The current version of Funky works in two phases: it first creates an <em>abstract syntax tree</em> by parsing the input you pass to it. It then prunes the tree of anything that is can see as a function, and stores those functions in an internal map, with the function pointers you may already have given it. As every function can only have one definition, the script's definitions of any functions you may have put in the interpreter will override anything you have given it at that point - but you can install functions after the parsing phase.</p>
					 <p>Once it starts evaluating the parsed script, it creates an <em>evaluator</em> and passes the parsed "main" function to it - the main function is the function without an explicit name that comes at the end of the script. The evaluator traverses the AST, calls any functions that need calling and will finally return with a value, which will be the return value of the script.</p>
					 <p>Hence, running a script goes through two distinct phases: parsing and evaluating, which allows you to determine which functions can be overridden by user scripts (the ones you install before parsing) and which can't (the ones you install after parsing).</p>

					 <h2>How can I use Funky?</h2>
					 <p>For your convenience, the source distribution contains a "solution" file for Microsoft Visual Studio 2005 as well as a GNU autoconf-generated configury. The GNU "project" files do not use GNU automake, but do use GNU libtool and have been tested on <a href="http://www.debian.org" target="_blank">Debian GNU/Linux Stable</a> and on <a href="http://cygwin.com" target="_blank">Cygwin</a>http://cygwin.com</p>
					 <p>In order to compile Funky, you need to have a version of Boost that includes Boost.Spirit installed somewhere where your compiler can find it. You also need <a href="http://loki-lib.sourceforge.net" target="_blank">Loki</a> by Andrei Alexandrescu for its ScopeGuard.</p>
					 <p>As far as I know, I cannot legaly distribute the DLL compiled with Visual Studio so, for the time being, you will have to compile it yourself. If there is any demand for it, I will create a C API for Funky and distribute a DLL compiled with <a href="http://www.mingw.org" target="_blank">MinGW</a>.</p>
					 <p>Should there be any demand for them, I'll be happy to create Debian and/or Cygwin packaged of Funky as well.</p>
			</body>
</html>

